/*******************************************************************************
 * thrill/mem/manager.cpp
 *
 * Part of Project Thrill - http://project-thrill.org
 *
 * Copyright (C) 2015 Timo Bingmann <tb@panthema.net>
 *
 * All rights reserved. Published under the BSD-2 license in the LICENSE file.
 ******************************************************************************/

#include <thrill/common/logger.hpp>
#include <thrill/mem/manager.hpp>

#include <cstdio>

namespace thrill {
namespace mem {

Manager::~Manager() {
    // You can not use the logger here, because there is maybe no
    // LoggerAllocator any more
    if (debug) {
        printf("mem::Manager() name=%s alloc_count_=%zu peak_=%zu total_=%zu\n",
               name_, alloc_count_.load(), peak_.load(), total_.load());
    }
}

Manager g_bypass_manager(nullptr, "Bypass");

} // namespace mem
} // namespace thrill

/******************************************************************************/
